"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.websocket = void 0;
const laravel_echo_1 = __importDefault(require("laravel-echo"));
const pusher_js_1 = __importDefault(require("pusher-js"));
const dotenv_1 = require("dotenv");
const auth_1 = require("./api/auth");
const axios_1 = require("./axios");
(0, dotenv_1.config)();
if (!process)
    throw new Error("falha");
const websocket = () => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
        const login = new auth_1.Auth;
        const admin = yield login.login(String(process.env.EMAIL), String(process.env.PASSWORD));
        if (!admin)
            return reject("Falha ao logar o usuario");
        axios_1.Axios.defaults.headers.common.Authorization = `Bearer ${admin.access_token}`;
        // @ts-ignore
        global.Pusher = pusher_js_1.default;
        // @ts-ignore
        global.id = admin.id;
        //     Criação da instancia do laravel ECHO
        /**
         * Servidor local 127.0.0.1:8000, porta local, autentiquei com a URL completa usando o autenticador sanctum do laravel, verifique no arquivo de rotas channel.php
         *
         *
         * channelAuthorization: {
         *             endpoint: "http://127.0.0.1:8000/broadcasting/auth",
         *             headers: {
         *                 Authorization: "Bearer " + admin.access_token,
         *             }
         *         }
         *
         */
        const echo = new laravel_echo_1.default({
            broadcaster: 'pusher',
            cluster: process.env.PUSHER_APP_CLUSTER,
            key: process.env.PUSHER_APP_KEY,
            wsHost: process.env.PUSHER_HOST,
            wsPort: 6001,
            forceTLS: false,
            disableStats: true,
            enabledTransports: ['ws', 'wss'],
            channelAuthorization: {
                endpoint: "http://127.0.0.1:8000/broadcasting/auth",
                headers: {
                    Authorization: "Bearer " + admin.access_token,
                }
            }
        });
        resolve(echo);
    }));
});
exports.websocket = websocket;
