import Echo from "laravel-echo"
import Pusher from "pusher-js"
import {config} from "dotenv"
import {Auth} from "./api/auth";
import {Axios} from "./axios";

config()


if (!process) throw new Error("falha")



export const websocket = async (): Promise<Echo> => {

    return new Promise(async (resolve, reject) => {

        const login = new Auth

        const admin = await login.login(String(process.env.EMAIL), String(process.env.PASSWORD))

        if (!admin) return reject("Falha ao logar o usuario")

        Axios.defaults.headers.common.Authorization = `Bearer ${admin.access_token}`


        // @ts-ignore
        global.Pusher = Pusher;
        // @ts-ignore
        global.id = admin.id
//     Criação da instancia do laravel ECHO

        /**
         * Servidor local 127.0.0.1:8000, porta local, autentiquei com a URL completa usando o autenticador sanctum do laravel, verifique no arquivo de rotas channel.php
         *
         *
         * channelAuthorization: {
         *             endpoint: "http://127.0.0.1:8000/broadcasting/auth",
         *             headers: {
         *                 Authorization: "Bearer " + admin.access_token,
         *             }
         *         }
         *
         */



        const echo = new Echo({
            broadcaster: 'pusher',
            cluster: process.env.PUSHER_APP_CLUSTER,
            key: process.env.PUSHER_APP_KEY,
            wsHost: process.env.PUSHER_HOST,
            wsPort: 6001,
            forceTLS: false,
            disableStats: true,
            enabledTransports: ['ws', 'wss'],
            channelAuthorization: {
                endpoint: "http://127.0.0.1:8000/broadcasting/auth",
                headers: {
                    Authorization: "Bearer " + admin.access_token,
                }
            }

        });


        resolve(echo)

    })


}


