export interface Chat {
    id: number;
    name: string;
    chat_number_phone: number;
    status: boolean;
    main: boolean;
    created_at: string;
    updated_at: string;
    chats: ChatDetail[];
    settings: null | any; // Use o tipo correto para 'settings' se possível
    messages_predefined: MessagePredefined[];
    chat_notifications: {
        id: number;
        notification_browser: boolean;
    };
    profile: {
        data: string;
    };
    label: Label[];
    chat_not_active: {
        id: number;
        name: string;
    }[];
}

interface ChatDetail {
    status: string;
    id: number;
    name: string;
    email: string;
    email_verified_at: string;
    created_at: string;
    updated_at: string;
    role: string;
    pivot: {
        chat_id: number;
        client_id: number;
    };
}

interface MessagePredefined {
    id: number;
    is_default: boolean;
    title: string;
    message: string;
}

interface Label {
    id: number;
    is_default: boolean;
    name: string;
}

export interface ChatInterface {
    getByActive(): Promise<Chat>
}
